/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-visp-camera-calibration-0.7.5-0quantal-20140905-2353/srv/calibrate.srv
 *
 */


#ifndef VISP_CAMERA_CALIBRATION_MESSAGE_CALIBRATEREQUEST_H
#define VISP_CAMERA_CALIBRATION_MESSAGE_CALIBRATEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace visp_camera_calibration
{
template <class ContainerAllocator>
struct calibrateRequest_
{
  typedef calibrateRequest_<ContainerAllocator> Type;

  calibrateRequest_()
    : method(0)
    , sample_width(0)
    , sample_height(0)  {
    }
  calibrateRequest_(const ContainerAllocator& _alloc)
    : method(0)
    , sample_width(0)
    , sample_height(0)  {
    }



   typedef int32_t _method_type;
  _method_type method;

   typedef int32_t _sample_width_type;
  _sample_width_type sample_width;

   typedef int32_t _sample_height_type;
  _sample_height_type sample_height;




  typedef boost::shared_ptr< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct calibrateRequest_

typedef ::visp_camera_calibration::calibrateRequest_<std::allocator<void> > calibrateRequest;

typedef boost::shared_ptr< ::visp_camera_calibration::calibrateRequest > calibrateRequestPtr;
typedef boost::shared_ptr< ::visp_camera_calibration::calibrateRequest const> calibrateRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace visp_camera_calibration

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'visp_camera_calibration': ['/tmp/buildd/ros-groovy-visp-camera-calibration-0.7.5-0quantal-20140905-2353/msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "7b57c459896a8f1f8df45a385acfc123";
  }

  static const char* value(const ::visp_camera_calibration::calibrateRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x7b57c459896a8f1fULL;
  static const uint64_t static_value2 = 0x8df45a385acfc123ULL;
};

template<class ContainerAllocator>
struct DataType< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "visp_camera_calibration/calibrateRequest";
  }

  static const char* value(const ::visp_camera_calibration::calibrateRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int32 method\n\
int32 sample_width\n\
int32 sample_height\n\
";
  }

  static const char* value(const ::visp_camera_calibration::calibrateRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.method);
      stream.next(m.sample_width);
      stream.next(m.sample_height);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct calibrateRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::visp_camera_calibration::calibrateRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::visp_camera_calibration::calibrateRequest_<ContainerAllocator>& v)
  {
    s << indent << "method: ";
    Printer<int32_t>::stream(s, indent + "  ", v.method);
    s << indent << "sample_width: ";
    Printer<int32_t>::stream(s, indent + "  ", v.sample_width);
    s << indent << "sample_height: ";
    Printer<int32_t>::stream(s, indent + "  ", v.sample_height);
  }
};

} // namespace message_operations
} // namespace ros

#endif // VISP_CAMERA_CALIBRATION_MESSAGE_CALIBRATEREQUEST_H
