# generated from catkin/cmake/template/pkgConfig.cmake.in

# append elements to a list and remove existing duplicates from the list
# copied from catkin/cmake/list_append_deduplicate.cmake to keep pkgConfig
# self contained
macro(_list_append_deduplicate listname)
  if(NOT "${ARGN}" STREQUAL "")
    if(${listname})
      list(REMOVE_ITEM ${listname} ${ARGN})
    endif()
    list(APPEND ${listname} ${ARGN})
  endif()
endmacro()

# append elements to a list if they are not already in the list
# copied from catkin/cmake/list_append_unique.cmake to keep pkgConfig
# self contained
macro(_list_append_unique listname)
  foreach(_item ${ARGN})
    list(FIND ${listname} ${_item} _index)
    if(_index EQUAL -1)
      list(APPEND ${listname} ${_item})
    endif()
  endforeach()
endmacro()

# pack a list of libraries with optional build configuration keywords
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_pack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  set(_argn ${ARGN})
  list(LENGTH _argn _count)
  set(_index 0)
  while(${_index} LESS ${_count})
    list(GET _argn ${_index} lib)
    if("${lib}" MATCHES "^debug|optimized|general$")
      math(EXPR _index "${_index} + 1")
      if(${_index} EQUAL ${_count})
        message(FATAL_ERROR "_pack_libraries_with_build_configuration() the list of libraries '${ARGN}' ends with '${lib}' which is a build configuration keyword and must be followed by a library")
      endif()
      list(GET _argn ${_index} library)
      list(APPEND ${VAR} "${lib}${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}${library}")
    else()
      list(APPEND ${VAR} "${lib}")
    endif()
    math(EXPR _index "${_index} + 1")
  endwhile()
endmacro()

# unpack a list of libraries with optional build configuration keyword prefixes
# copied from catkin/cmake/catkin_libraries.cmake to keep pkgConfig
# self contained
macro(_unpack_libraries_with_build_configuration VAR)
  set(${VAR} "")
  foreach(lib ${ARGN})
    string(REGEX REPLACE "^(debug|optimized|general)${CATKIN_BUILD_CONFIGURATION_KEYWORD_SEPARATOR}(.+)$" "\\1;\\2" lib "${lib}")
    list(APPEND ${VAR} "${lib}")
  endforeach()
endmacro()


if(visp_camera_calibration_CONFIG_INCLUDED)
  return()
endif()
set(visp_camera_calibration_CONFIG_INCLUDED TRUE)

# set variables for source/devel/install prefixes
if("FALSE" STREQUAL "TRUE")
  set(visp_camera_calibration_SOURCE_PREFIX /tmp/buildd/ros-groovy-visp-camera-calibration-0.7.5-0quantal-20140905-2353)
  set(visp_camera_calibration_DEVEL_PREFIX /tmp/buildd/ros-groovy-visp-camera-calibration-0.7.5-0quantal-20140905-2353/obj-x86_64-linux-gnu/devel)
  set(visp_camera_calibration_INSTALL_PREFIX "")
  set(visp_camera_calibration_PREFIX ${visp_camera_calibration_DEVEL_PREFIX})
else()
  set(visp_camera_calibration_SOURCE_PREFIX "")
  set(visp_camera_calibration_DEVEL_PREFIX "")
  set(visp_camera_calibration_INSTALL_PREFIX /opt/ros/groovy)
  set(visp_camera_calibration_PREFIX ${visp_camera_calibration_INSTALL_PREFIX})
endif()

# warn when using a deprecated package
if(NOT "" STREQUAL "")
  set(_msg "WARNING: package 'visp_camera_calibration' is deprecated")
  # append custom deprecation text if available
  if(NOT "" STREQUAL "TRUE")
    set(_msg "${_msg} ()")
  endif()
  message("${_msg}")
endif()

# flag project as catkin-based to distinguish if a find_package()-ed project is a catkin project
set(visp_camera_calibration_FOUND_CATKIN_PROJECT TRUE)

if(NOT "include;/opt/ros/groovy/include;/usr/include;/usr/include/OGRE;/usr/include/ois;/usr/include/libxml2;/opt/ros/groovy/include/opencv" STREQUAL "")
  set(visp_camera_calibration_INCLUDE_DIRS "")
  set(_include_dirs "include;/opt/ros/groovy/include;/usr/include;/usr/include/OGRE;/usr/include/ois;/usr/include/libxml2;/opt/ros/groovy/include/opencv")
  foreach(idir ${_include_dirs})
    if(IS_ABSOLUTE ${idir} AND IS_DIRECTORY ${idir})
      set(include ${idir})
    elseif("${idir}" STREQUAL "include")
      get_filename_component(include "${visp_camera_calibration_DIR}/../../../include" ABSOLUTE)
      if(NOT IS_DIRECTORY ${include})
        message(FATAL_ERROR "Project 'visp_camera_calibration' specifies '${idir}' as an include dir, which is not found.  It does not exist in '${include}'.  Ask the maintainer 'Fabien Spindler <Fabien.Spindler@inria.fr>' to fix it.")
      endif()
    else()
      message(FATAL_ERROR "Project 'visp_camera_calibration' specifies '${idir}' as an include dir, which is not found.  It does neither exist as an absolute directory nor in '/opt/ros/groovy/${idir}'.  Ask the maintainer 'Fabien Spindler <Fabien.Spindler@inria.fr>' to fix it.")
    endif()
    _list_append_unique(visp_camera_calibration_INCLUDE_DIRS ${include})
  endforeach()
endif()

set(libraries "debug;/opt/ros/groovy/lib/libvisp.so;optimized;/opt/ros/groovy/lib/libvisp.so;/usr/lib/liblapack.so;/usr/lib/libblas.so;/usr/lib/x86_64-linux-gnu/libm.so;/usr/lib/libboost_thread-mt.so;pthread;/usr/lib/libboost_date_time-mt.so;optimized;/usr/lib/x86_64-linux-gnu/libOgreMain.so;debug;/usr/lib/x86_64-linux-gnu/libOgreMain.so;optimized;/usr/lib/x86_64-linux-gnu/libOIS.so;debug;/usr/lib/x86_64-linux-gnu/libOIS.so;/usr/lib/x86_64-linux-gnu/libGLU.so;/usr/lib/x86_64-linux-gnu/libGL.so;/usr/lib/x86_64-linux-gnu/libSM.so;/usr/lib/x86_64-linux-gnu/libICE.so;/usr/lib/x86_64-linux-gnu/libX11.so;/usr/lib/x86_64-linux-gnu/libXext.so;/usr/lib/libCoin.so;/usr/lib/x86_64-linux-gnu/libxml2.so;/usr/lib/x86_64-linux-gnu/libfreenect.so;/usr/lib/x86_64-linux-gnu/libpthread.so;opencv_videostab;opencv_video;opencv_ts;opencv_superres;opencv_stitching;opencv_photo;opencv_objdetect;opencv_nonfree;opencv_ml;opencv_legacy;opencv_imgproc;opencv_highgui;opencv_gpu;opencv_flann;opencv_features2d;opencv_core;opencv_contrib;opencv_calib3d;/usr/lib/x86_64-linux-gnu/libjpeg.so;/usr/lib/x86_64-linux-gnu/libpng.so;/usr/lib/x86_64-linux-gnu/libswscale.so;/usr/lib/x86_64-linux-gnu/libavformat.so;/usr/lib/x86_64-linux-gnu/libavcodec.so;/usr/lib/x86_64-linux-gnu/libavutil.so;/usr/lib/x86_64-linux-gnu/libz.so;/usr/lib/x86_64-linux-gnu/libbz2.so;/usr/lib/x86_64-linux-gnu/libdc1394.so;/usr/lib/x86_64-linux-gnu/libv4l2.so;/usr/lib/x86_64-linux-gnu/libv4lconvert.so")
foreach(library ${libraries})
  # keep build configuration keywords, target names and absolute libraries as-is
  if("${library}" MATCHES "^debug|optimized|general$")
    list(APPEND visp_camera_calibration_LIBRARIES ${library})
  elseif(TARGET ${library})
    list(APPEND visp_camera_calibration_LIBRARIES ${library})
  elseif(IS_ABSOLUTE ${library})
    list(APPEND visp_camera_calibration_LIBRARIES ${library})
  else()
    set(lib_path "")
    set(lib "${library}-NOTFOUND")
    # since the path where the library is found is returned we have to iterate over the paths manually
    foreach(path /opt/ros/groovy/lib;/opt/ros/groovy/lib)
      find_library(lib ${library}
        PATHS ${path}
        NO_DEFAULT_PATH NO_CMAKE_FIND_ROOT_PATH)
      if(lib)
        set(lib_path ${path})
        break()
      endif()
    endforeach()
    if(lib)
      _list_append_unique(visp_camera_calibration_LIBRARY_DIRS ${lib_path})
      list(APPEND visp_camera_calibration_LIBRARIES ${lib})
    else()
      # as a fall back for non-catkin libraries try to search globally
      find_library(lib ${library})
      if(NOT lib)
        message(FATAL_ERROR "Project '${PROJECT_NAME}' tried to find library '${library}'.  The library is neither a target nor built/installed properly.  Did you compile project 'visp_camera_calibration'?  Did you find_package() it before the subdirectory containing its code is included?")
      endif()
      list(APPEND visp_camera_calibration_LIBRARIES ${lib})
    endif()
  endif()
endforeach()

set(visp_camera_calibration_EXPORTED_TARGETS "visp_camera_calibration_generate_messages_cpp;visp_camera_calibration_generate_messages_lisp;visp_camera_calibration_generate_messages_py")
# create dummy targets for exported code generation targets to make life of users easier
foreach(t ${visp_camera_calibration_EXPORTED_TARGETS})
  if(NOT TARGET ${t})
    add_custom_target(${t})
  endif()
endforeach()

set(depends "message_runtime;sensor_msgs;std_msgs;geometry_msgs")
foreach(depend ${depends})
  string(REPLACE " " ";" depend_list ${depend})
  # the package name of the dependency must be kept in a unique variable so that it is not overwritten in recursive calls
  list(GET depend_list 0 visp_camera_calibration_dep)
  list(LENGTH depend_list count)
  if(${count} EQUAL 1)
    # simple dependencies must only be find_package()-ed once
    if(NOT ${visp_camera_calibration_dep}_FOUND)
      find_package(${visp_camera_calibration_dep} REQUIRED)
    endif()
  else()
    # dependencies with components must be find_package()-ed again
    list(REMOVE_AT depend_list 0)
    find_package(${visp_camera_calibration_dep} REQUIRED ${depend_list})
  endif()
  _list_append_unique(visp_camera_calibration_INCLUDE_DIRS ${${visp_camera_calibration_dep}_INCLUDE_DIRS})

  # merge build configuration keywords with library names to correctly deduplicate
  _pack_libraries_with_build_configuration(visp_camera_calibration_LIBRARIES ${visp_camera_calibration_LIBRARIES})
  _pack_libraries_with_build_configuration(_libraries ${${visp_camera_calibration_dep}_LIBRARIES})
  _list_append_deduplicate(visp_camera_calibration_LIBRARIES ${_libraries})
  # undo build configuration keyword merging after deduplication
  _unpack_libraries_with_build_configuration(visp_camera_calibration_LIBRARIES ${visp_camera_calibration_LIBRARIES})

  _list_append_unique(visp_camera_calibration_LIBRARY_DIRS ${${visp_camera_calibration_dep}_LIBRARY_DIRS})
  list(APPEND visp_camera_calibration_EXPORTED_TARGETS ${${visp_camera_calibration_dep}_EXPORTED_TARGETS})
endforeach()

set(pkg_cfg_extras "visp_camera_calibration-msg-extras.cmake")
foreach(extra ${pkg_cfg_extras})
  if(NOT IS_ABSOLUTE ${extra})
    set(extra ${visp_camera_calibration_DIR}/${extra})
  endif()
  include(${extra})
endforeach()
